from numpy import *
import util

class TennisData:
    #              Outlook      Temperature  Hum   Wind
    #             S?  O?  R?     H?  M?  C?    H?    S?
    X = array([[  1,  0,  0,     1,  0,  0,    1,    0   ],
               [  1,  0,  0,     1,  0,  0,    1,    1   ],
               [  0,  1,  0,     1,  0,  0,    1,    0   ],
               [  0,  0,  1,     0,  1,  0,    1,    0   ],
               [  0,  0,  1,     0,  0,  1,    0,    0   ],
               [  0,  0,  1,     0,  0,  1,    0,    1   ],
               [  0,  1,  0,     0,  0,  1,    0,    1   ],
               [  1,  0,  0,     0,  1,  0,    1,    0   ],
               [  1,  0,  0,     0,  0,  1,    0,    0   ],
               [  0,  0,  1,     0,  1,  0,    0,    0   ],
               [  1,  0,  0,     0,  1,  0,    0,    1   ],
               [  0,  1,  0,     0,  1,  0,    1,    1   ],
               [  0,  1,  0,     1,  0,  0,    0,    0   ],
               [  0,  0,  1,     0,  1,  0,    1,    1   ]
               ], dtype=float)

    Y = array([ -1, -1, 1, 1, 1, -1, 1, -1, 1, 1, 1, 1, 1, -1 ], dtype=float)

    #              Outlook      Temperature  Hum   Wind
    #             S?  O?  R?     H?  M?  C?    H?    S?
    Xte=array([[  1,  0,  0,     1,  0,  0,    1,    0   ],
               [  1,  0,  0,     1,  0,  0,    1,    1   ],
               [  0,  0,  1,     0,  0,  1,    0,    0   ],
               [  0,  1,  0,     0,  0,  1,    0,    1   ],
               [  1,  0,  0,     0,  0,  1,    0,    0   ],
               [  0,  0,  1,     0,  1,  0,    1,    1   ]
               ], dtype=float)

    Yte=array([ -1, -1, 1, 1, 1, -1 ], dtype=float)


class TwoDAxisAligned:
    X = array([[ 0.1,  0.2,  0.3,  0.4,  0.5,  0.6,  0.7,  0.8,  0.9,  1. ,  0.1,
                 0.2,  0.3,  0.4,  0.5,  0.6,  0.7,  0.8,  0.9,  1. ,  0.1,  0.2,
                 0.3,  0.4,  0.5,  0.6,  0.7,  0.8,  0.9,  1. ,  0.1,  0.2,  0.3,
                 0.4,  0.5,  0.6,  0.7,  0.8,  0.9,  1. ,  0.1,  0.2,  0.3,  0.4,
                 0.5,  0.6,  0.7,  0.8,  0.9,  1. ,  0.1,  0.2,  0.3,  0.4,  0.5,
                 0.6,  0.7,  0.8,  0.9,  1. ,  0.1,  0.2,  0.3,  0.4,  0.5,  0.6,
                 0.7,  0.8,  0.9,  1. ,  0.1,  0.2,  0.3,  0.4,  0.5,  0.6,  0.7,
                 0.8,  0.9,  1. ,  0.1,  0.2,  0.3,  0.4,  0.5,  0.6,  0.7,  0.8,
                 0.9,  1. ,  0.1,  0.2,  0.3,  0.4,  0.5,  0.6,  0.7,  0.8,  0.9,
                 1. ],
               [ 0.1,  0.1,  0.1,  0.1,  0.1,  0.1,  0.1,  0.1,  0.1,  0.1,  0.2,
                 0.2,  0.2,  0.2,  0.2,  0.2,  0.2,  0.2,  0.2,  0.2,  0.3,  0.3,
                 0.3,  0.3,  0.3,  0.3,  0.3,  0.3,  0.3,  0.3,  0.4,  0.4,  0.4,
                 0.4,  0.4,  0.4,  0.4,  0.4,  0.4,  0.4,  0.5,  0.5,  0.5,  0.5,
                 0.5,  0.5,  0.5,  0.5,  0.5,  0.5,  0.6,  0.6,  0.6,  0.6,  0.6,
                 0.6,  0.6,  0.6,  0.6,  0.6,  0.7,  0.7,  0.7,  0.7,  0.7,  0.7,
                 0.7,  0.7,  0.7,  0.7,  0.8,  0.8,  0.8,  0.8,  0.8,  0.8,  0.8,
                 0.8,  0.8,  0.8,  0.9,  0.9,  0.9,  0.9,  0.9,  0.9,  0.9,  0.9,
                 0.9,  0.9,  1. ,  1. ,  1. ,  1. ,  1. ,  1. ,  1. ,  1. ,  1. ,
                 1. ]]).T - 0.45
    Y = (X[:,0] > 0.1) * 2 - 1.

    Xte = X - 0.05
    Yte = (Xte[:,0] > 0.1) * 2 - 1.

    
class TwoDDiagonal:
    X = array([[ 0.1,  0.2,  0.3,  0.4,  0.5,  0.6,  0.7,  0.8,  0.9,  1. ,  0.1,
                 0.2,  0.3,  0.4,  0.5,  0.6,  0.7,  0.8,  0.9,  1. ,  0.1,  0.2,
                 0.3,  0.4,  0.5,  0.6,  0.7,  0.8,  0.9,  1. ,  0.1,  0.2,  0.3,
                 0.4,  0.5,  0.6,  0.7,  0.8,  0.9,  1. ,  0.1,  0.2,  0.3,  0.4,
                 0.5,  0.6,  0.7,  0.8,  0.9,  1. ,  0.1,  0.2,  0.3,  0.4,  0.5,
                 0.6,  0.7,  0.8,  0.9,  1. ,  0.1,  0.2,  0.3,  0.4,  0.5,  0.6,
                 0.7,  0.8,  0.9,  1. ,  0.1,  0.2,  0.3,  0.4,  0.5,  0.6,  0.7,
                 0.8,  0.9,  1. ,  0.1,  0.2,  0.3,  0.4,  0.5,  0.6,  0.7,  0.8,
                 0.9,  1. ,  0.1,  0.2,  0.3,  0.4,  0.5,  0.6,  0.7,  0.8,  0.9,
                 1. ],
               [ 0.1,  0.1,  0.1,  0.1,  0.1,  0.1,  0.1,  0.1,  0.1,  0.1,  0.2,
                 0.2,  0.2,  0.2,  0.2,  0.2,  0.2,  0.2,  0.2,  0.2,  0.3,  0.3,
                 0.3,  0.3,  0.3,  0.3,  0.3,  0.3,  0.3,  0.3,  0.4,  0.4,  0.4,
                 0.4,  0.4,  0.4,  0.4,  0.4,  0.4,  0.4,  0.5,  0.5,  0.5,  0.5,
                 0.5,  0.5,  0.5,  0.5,  0.5,  0.5,  0.6,  0.6,  0.6,  0.6,  0.6,
                 0.6,  0.6,  0.6,  0.6,  0.6,  0.7,  0.7,  0.7,  0.7,  0.7,  0.7,
                 0.7,  0.7,  0.7,  0.7,  0.8,  0.8,  0.8,  0.8,  0.8,  0.8,  0.8,
                 0.8,  0.8,  0.8,  0.9,  0.9,  0.9,  0.9,  0.9,  0.9,  0.9,  0.9,
                 0.9,  0.9,  1. ,  1. ,  1. ,  1. ,  1. ,  1. ,  1. ,  1. ,  1. ,
                 1. ]]).T - 0.45
    Y = (X[:,0] + 3 * X[:,1] > 0) * 2 - 1.

    Xte = X - 0.05
    Yte = (Xte[:,0] + 3 * Xte[:,1] > 0.4) * 2 - 1.
    

